// Ant.h
//--------------------------------------------------------------------
#import <objectbase/SwarmObject.h>
#import <space.h>
#import <random.h>
#import <gui.h>
#import "MoGrid2d.h"    // we use Sven Thommesen class to allow
                        // multiple occupancy in a grid
#import "TraceSpace.h"
#import "CW_DataWarehouse.h"
#import "CW_Interface.h"
#import "CW_RuleMaster.h"
#import "EH_Trace.h"
//--------------------------------------------------------------------

@interface Ant: SwarmObject
{

  id   environment;
  CW_DataWarehouse * dataWarehouse;
  CW_Interface     * interface;
  MoGrid2d         * world;
  TraceSpace       * traces;
  CW_RuleMaster    * ruleMaster;
  float reproductionRate;
  int  xPos, yPos, direction, color;
  int  worldXSize, worldYSize;

}

//--------------------------------------------------------------------

-   setEnvironment: mS
        ruleMaster: rp
     dataWarehouse: dW
         interface: it
  reproductionRate: (float) rR
              posX: (int) pX
              posY: (int) pY
         direction: (int) d
             color: (int) c;

- createEnd;

- (int) getDirection;
- (int) getPosX;
- (int) getPosY;
- (int) getColor;

- move;
- generate;
- drawSelfOn: (id <Raster>)r;
- print;

//--------------------------------------------------------------------

@end
