// CW_Interface.m
//--------------------------------------------------------------------

#import "CW_Interface.h"

//--------------------------------------------------------------------

@implementation CW_Interface

//--------------------------------------------------------------------
//Here we set initial values of counters and constant eyeCatcher
//that will be useful to find the area in a memory-dump

- createEnd
{

   id obj;

TRACEC(printf("\n%8X Interface - entry createEnd\n",(int) self);)

   eyeCatcher[0] = 'I';
   eyeCatcher[0] = 'N';
   eyeCatcher[0] = 'T';
   eyeCatcher[0] = 'F';

   obj = [super createEnd];

TRACEC(printf("%8X Interface - exit createEnd %8X\n\n",
       (int) self,(int) obj);)

   return obj;

}

//--------------------------------------------------------------------

- setEventsToMap: (int) eN
{

TRACEC(printf("\n%8X Interface - entry setEventsToMap: %d\n",(int) self,eN);)

   eventsToMap = eN;

TRACEC(printf("%8X Interface - exit setEventsToMap %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- (char *) getEventsMap
{

TRACEC(printf("\n%8X Interface - entry getEventsMap\n",(int) self);)
TRACEC(printf("%8X Interface - exit getEventsMap %8X\n\n",
              (int) self,(int) &eventsMap[0]);)

   return &eventsMap[0];

}

//--------------------------------------------------------------------

- setSuggestionMap: (char *) sM
{

   int i;

TRACEC(printf("\n%8X Interface - entry setSuggestionMap: %8X\n",
              (int) self,(int) sM);)

   for(i=0;i<eventsToMap;i++) suggestionMap[i] = sM[i];

TRACEC(printf("%8X Interface - exit setSuggestionMap %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- encodeColor: (int) i1 trace: (int) i2 direction: (int) i3
{

   int i;

TRACEC(printf("\n%8X Interface - entry encode: %d\n",(int) self,n);)

   for (i=0;i<eventsToMap;i++) eventsMap[i] = '0';

// if (i1 == 3) eventsMap[0] = '1';
   if (i2 == 1) eventsMap[1] = '1';
   if (i3 >= 2) {eventsMap[2] = '1'; i3 = i3 - 2;}
   if (i3 == 1) eventsMap[3] = '1';

TRACEC(printf("%8X Interface - exit encode %8X\n\n",
              (int) self,(int) self);)

   return self;

}

//--------------------------------------------------------------------

- (int) decode
{

   double w=0;
   int j;

TRACEC(printf("\n%8X Interface - entry decode\n",(int) self);)

   for(j=0;j<eventsToMap;j++)
      if(suggestionMap[j] == '1') w = w + pow(2,eventsToMap-j-1);
   j = (int) w;

TRACEC(printf("%8X Interface - exit decode %d\n\n",(int) self,j);)

   return j;

}

//--------------------------------------------------------------------
@end
