// CW_Message.m
//-------------------------------------------------------------------
//Because a swarm's object is named message we've truncated the name
//of this object.

#import"CW_Message.h"

@implementation CW_Message

//-------------------------------------------------------------------

- createEnd
{

   id obj;

TRACE9 (printf("\n%8X Message - entry createEnd\n",(int) self);)

   eyeCatcher[0] = 'M';
   eyeCatcher[0] = 'E';
   eyeCatcher[0] = 'S';
   eyeCatcher[0] = 'S';
   sumSupport    = 0;
   maxSupport    = 0;
   times         = 0;
   obj = [super createEnd];

TRACE9 (printf("%8X Message - exit createEnd %8X\n\n",
        (int) self,(int) obj);)

   return obj;

}

//-------------------------------------------------------------------

- setText: (char *)    aS length: (int) ll owner: (id) ow
     dump: (EH_Dump *) du;
{

   int i;

TRACE9 (printf("\n%8X Message - entry setText: %8X\n",
               (int) self,(int) aS);)
TRACE9 (printf("                          length: %d\n",ll);)
TRACE9 (printf("                           owner: %8X\n",(int) ow);)
TRACE9 (printf("                            dump: %8X\n",(int) du);)
TRACE9 ([du dumpFromAddress: (id) aS forLength: ll];)

   length = ll;
   owner  = ow;
   dump   = du;

   for(i=0;i<length;i++) text[i] = aS[i];

TRACE9 (printf("%8X Message - exit setText %8X\n\n",
               (int) self,(int) self);)

   return self;

}

//-------------------------------------------------------------------

- (float) setSupport: (float) sV 
{
   sumSupport = sumSupport + sV;
   times++;

   if (times == 1)       {maxSupport = sV; return 1;} 
   if (maxSupport < sV)  {maxSupport = sV; return 2;}
   if (maxSupport == sV) return 1;
                         return 0;
}
- (int)   compareWith: (char*) cP
{
   int i;
   for(i=0;i<length;i++) if (text[i] != cP[i]) return 1;
   return 0;
}

//-------------------------------------------------------------------

- (char *) getText
{

TRACE9 (printf("\n%8X Message - entry getText\n",(int) self);)
TRACE9 (printf("%8X Message - exit getText %8X\n\n",
                (int) self,(int) &text[0]);)

   return &text[0];

}

//-------------------------------------------------------------------

- (id) getOwner
{

TRACE9 (printf("\n%8X Message - entry getOwner\n",(int) self);)
TRACE9 (printf("%8X Message - exit getOwner %8X\n\n",
        (int) self,(int) owner);)

   return owner;

}

//-------------------------------------------------------------------

- setOwner: (id) ow
{

TRACE9 (printf("\n%8X Message - entry setOwner: %8X\n",
        (int) self,(int) ow);)

   owner = ow;

TRACE9 (printf("%8X Message - exit setOwner %8X\n\n",
        (int) self,(int) self);)

   return self;

}

//-------------------------------------------------------------------

- print
{

   int i,j;

   for(i=0;i<length;i++) printf("%c",text[i]);
   j = (int) owner;

   printf(" from %8X %f times with max %f and mean %f\n",
            j,times,maxSupport,sumSupport/times);

   return self;

}

//-------------------------------------------------------------------
@end

