// AntEater.h
//--------------------------------------------------------------------
#import <objectbase/SwarmObject.h>
#import <space.h>
#import <random.h>
#import <gui.h>
#import "MoGrid2d.h"    // we use Sven Thommesen class to allow
                        // multiple occupancy in a grid
#import "TraceSpace.h"
#import "Ant.h"

#import "CW_RuleMaster.h"
#import "CW_DataWarehouse.h"
#import "CW_Interface.h"
#import "EH_Trace.h"
//--------------------------------------------------------------------

@interface Anteater: SwarmObject
{

  id   anAnt;
  id   environment;
  MoGrid2d         * world;
  TraceSpace       * traces;
  CW_DataWarehouse * dataWarehouse;
  CW_Interface     * interface;
  CW_RuleMaster    * ruleMaster;
  int  xPos, yPos, direction;
  int  worldXSize, worldYSize, tries, sw, eaten;
  char eventList[4];
}
//--------------------------------------------------------------------
- setEnvironment: mS
   dataWarehouse: dW
       interface: it
      ruleMaster: rp;

- createEnd;

- search;
- eat;

- print;

//--------------------------------------------------------------------

@end
