// PH_PArmWarehouse.h
//--------------------------------------------------------------------
#import <objectbase/SwarmObject.h>
#import <collections.h>
#import <string.h>
#import <stdlib.h>
#import <stdio.h>
//--------------------------------------------------------------------
@interface PH_ParmWarehouse: SwarmObject
{
   FILE*  filePtr;
   char   names[16384];
   char   types[256];
   int    intValues[256];
   float  floatValues[256];
   char   charValues[16384];

   char   name[64];
   char   type;
   int    intValue;
   float  floatValue;
   char   charValue[64];

   char   buffer[80];

   int    numberOfParms,row,currentParm;
}
//--------------------------------------------------------------------
-       createEnd;
- (int) loadFromFile: (char*) fP;
- (int) setParm: (char*) nP       fromFloat: (float*) fP;
- (int) setParm: (char*) nP       fromInteger: (int*) iP;
- (int) setParm: (char*) nP       fromString: (char*) sP;
- (int) addParm: (char*) nP       fromFloat: (float*) fP;
- (int) addParm: (char*) nP       fromInteger: (int*) iP;
- (int) addParm: (char*) nP       fromString: (char*) sP;
- (int) getParm: (char*) nP       intoFloat: (float*) fP;
- (int) getParm: (char*) nP       intoInteger: (int*) iP;
- (int) getParm: (char*) nP       intoString: (char*) sP
                                  withLength: (int)   ll;
- (int) getTypeOfParm: (char*) nP into: (char*) tP;
- (int) setTypeOfParm: (char*) nP from: (char*) tP;
-       print;
//--------------------------------------------------------------------
- (int) analyze;
- (int) findParm: (char*) nP;
- (int) add;
- (int) upd;
- (int) openFile: (char*) fP;
- (int) readInto: (char*) bP withLength: (int) ll;
- (int) closeFile;
//--------------------------------------------------------------------
@end
